/*******************************************************************************
		Main Program:	Viewer.cpp

		Comment:			I do not like his method if have time rewrite it

		Author:				Yu-Chi Lai, yu-chil@cae.wisc.edu

		Due Date:			

		Course:				CS777, Spring 2003
*******************************************************************************/
#include "LString.h"
////////////////////////////////////////////////////////////////////
//
//	Recursively Create the final string
//
////////////////////////////////////////////////////////////////////
bool LString::Parse()
{
	return Parse(-1);
}
//******************************************************************
// Expand l-system into production string
//******************************************************************
bool LString::Parse(const signed short int reclevel)
{
	size_t          k,remaining,s;
  signed short int  l, lev = get_lev();
  LlineClass      *i;
  bool            marker = false, fractional_recursion;

  if (valid_string==false) {
    return false;
  }
  
  //store the actual number of recursions done in FS_Lev
  if ((reclevel<0) || (reclevel==lev)) {  // use the Lstring rec level
    fractional_recursion=growing();
    FS_Lev = lev;
  }
	else if (lev>reclevel) {              // use a lower rec level
    fractional_recursion=false;
    FS_Lev = reclevel;
  }
	else {   // a rec level higher than that defined has been requested
    return false;
  }
	printf("Recursion level used is %i\n",FS_Lev);
  //allocate FinalString and so forth (assumes 'char' is 1 byte)
  FS_Lgth=0;

  //initially allocate FS_Chunk of memory if we have none
  if (FinalString==NULL)
    if (FS_alloc(FS_Chunk)==false)
      return false;

	//see if we need more memory for the axiom
	printf("Allocating more memory for FinalString\n");
  k = line_ptr[AXIOM_LINE]->info_length();
	int needSize;
	if(k + 1 > FS_MemSize)
		needSize = k + 1;
	else
		needSize = FS_MemSize;

  if (FS_alloc(needSize)==false)
    return false;

  strncpy((char *) FinalString, 
	  line_ptr[AXIOM_LINE]->text().c_str(), 
	  k);
  FinalString[k]='\0'; //make sure string is terminated

  //*******************************
  //******* Start parsing *********
  //*******************************
  remaining=k; //count of characters remaining to parse
  for (l = 0; l < FS_Lev; l++) {
    k=0;
    marker = ((l == (FS_Lev - 1)) && fractional_recursion); 
        
    //start a single pass of the parser: k is the current parse position
    while (FinalString[k]!='\0') {
      i  = RuleForChar[FinalString[k]]; // i points to a replacement rule
      s  = i->info_length();            // s is total length of rule

      //longer string needed
      if ((k+s+remaining+2) > FS_MemSize) {
				if (FS_alloc(FS_MemSize+FS_Chunk)==false) {
					free(FinalString);
					FS_MemSize=0;
					FS_Lgth=0;
					return false;
				}
      }
      //replace character with rule, surrounded by the @ character
      //if this is the last round of recursion, and a fractional
      //recursion level has been requested.
      if (marker && (i->get_marker()==USER_RULE)) {
				memmove(&FinalString[k+s],&FinalString[k+1],remaining);
				FinalString[k]='@';
				memcpy(&FinalString[k+1],i->rule_start(),s-2);
				FinalString[k+s-1]='@';
				k+=s;
      } 
			else {
				memmove(&FinalString[k+s-2],&FinalString[k+1],remaining);
				memcpy(&FinalString[k],i->rule_start(),s-2);
				k+=s-2;
      }

      remaining --;                     // one character down      
    } //end of a single parse
    remaining=k; //reset the count of remaining characters
  } //end of series of parses
  FS_Lgth=k;
  return true;

/*	size_t  process;	// the character currently process

	// lev the recursion level, l loop variable 
  signed short int	l, lev = get_lev();

	LlineClass  *iterLine; // current operation iteration

  bool	marker = false; // Flag whether currently is last iteration and fraction has been set
	bool  fractional_recursion; // Flag whether the recursion have decimal part

	std::string currentIteration;

	// Print parse the information
	printf("### Parsed %p! ###\n", this);

  // None axiom exist
  if (valid_string == false) {
    return false;
  }

	//******************************************************  
  // Store the actual number of recursions done in FS_Lev
	//******************************************************
	// Use the LString rec level
  if ((reclevel < 0) || (reclevel == lev)) {  
		// Check whether recursion has decimal part
    fractional_recursion = growing();
		// Set up the final string level
    FS_Lev = lev;
  } // end of if
	// use a lower rec level
	else if (lev > reclevel) { 
    fractional_recursion = false;
    FS_Lev = reclevel;
  } // end of else if
	// a rec level higher than that defined has been requested
	// Which should never happens
	else   
    return false;

  // Print out the information
	printf("Recursion level used is %i\n", FS_Lev);
	printf("Allocating memory for FinalString\n");

  // Allocate FinalString and so forth (assumes 'char' is 1 byte)
  FS_Lgth = 0;
	OutputString = "";

  //*******************************
  // Start parsing 
  //*******************************
	OutputString = line_ptr[AXIOM_LINE]->text();
  for (l = 0; l < FS_Lev; l++) {
		printf("Output: %s\n", OutputString.c_str());
		currentIteration = "";
		process = 0;

	  // Start a single pass of the parser: process is the processing position
		while (OutputString[process] != '\0') {
			// iterLine points to a replacement rule
			iterLine  = RuleForChar[OutputString[process]]; 
			printf(".");
			// When it is final iteration of fraction we must put
			// @USER_RULE@
			if(marker && (iterLine->get_marker() == USER_RULE)){
				currentIteration += '@';
				if(iterLine->info_length() > 2)
					currentIteration += iterLine->rule_start();
				currentIteration += '@';
			}// end of if
			else{
				if(iterLine->info_length() > 2)
					currentIteration += iterLine->rule_start();
			}
			process++;
		} // End of while
		OutputString = currentIteration;
	}// end of while

  FS_Lgth = OutputString.length();
	FinalString = (unsigned char*)OutputString.c_str();

	printf("Output: %s\n", OutputString.c_str());
	printf("Final length is %i\n",FS_Lgth);
  return true;*/
}

//******************************************************************
// Check whether there is a "." in the recursion line
//******************************************************************
bool LString::growing()
{
  //if there is a decimal place in the recursion line...
  if (line_ptr[REC_LINE]->text().find('.') == std::string::npos)
    return false;
  else
    return true;
}

bool LString::FS_alloc(size_t mem)
{
  void *new_mem=realloc(FinalString,mem);
  if (new_mem) {
    FinalString=(unsigned char *) new_mem;
    FS_MemSize=mem;
    return true;
  } else {
    Warning("Memory is not enough");
    return false;
  }
}
