#ifndef _FUNCTION_H
#define _FUNCTION_H
#include "globals.h"
#include <string>
#include <math.h> 
#include <iostream.h>
#include <vector>
#include <fstream>

#include <maya/MStatus.h>

// Point header
#include <maya/MIntArray.h>
#include <maya/MDoubleArray.h>
#include <maya/MFloatPoint.h>
#include <maya/MFloatPointArray.h>
#include <maya/MPoint.h>
#include <maya/MPointArray.h>
// Selection header
#include <maya/MSelectionList.h>
#include <maya/MItSelectionList.h>
// Curve header
#include <maya/MFnNurbsCurve.h>
#include <maya/MItCurveCV.h>
#include <maya/MFnNurbsSurface.h>
#include <maya/MFnMesh.h>
// Global header
#include <maya/MGlobal.h>
#include <maya/MStatus.h>
#include <maya/MLibrary.h>
// Object
#include <maya/MDagPath.h>
#include <maya/MObject.h>
// I/O
#include <maya/MString.h>
#include <maya/MPxCommand.h>
#include <maya/MArgList.h>
#include <maya/MFileIO.h>

#include "../math/vect3.h"

extern		std::ofstream      outStream;


//******************************************************************************
// Macro for error checking
//******************************************************************************
#define checkErr(stat,msg)					\
    if ( MS::kSuccess != stat ) {		\
    printf("Error\n");					\
		return stat;										\
}


std::string snip_line(std::string &text);
MStatus BlockDraw(char *name, std::vector<vect3<float> > &vertex, unsigned short int colour);
MStatus SurfaceDraw(char *name, std::vector<vect3<float> > &vertex, unsigned short int colour);
MStatus CreateColorTable(std::vector<MString>& colorTable);

#endif